#include "buffer.h"

/**
 * $Id$
 */

int buffer_flushlines(buffer *b) {
  register char *p;
  register char *r;
  ssize_t bytes;

  if ((b == 0) ||
      (b->s == 0) ||
      (b->l != 0) ||
      (b->fd == -1)) return -1;
  p = b->c; r = b->s;
  if (p == r) return 0;
  for (;;) {
    --p; if (*p == '\n') break; if (p == r) goto nonlfound;
    --p; if (*p == '\n') break; if (p == r) goto nonlfound;
    --p; if (*p == '\n') break; if (p == r) goto nonlfound;
    --p; if (*p == '\n') break; if (p == r) goto nonlfound;
  }
  ++p;
  for (;;) {
    bytes = write(b->fd, r, p - r);
    if (bytes == -1) return -1;
    r += bytes;
    if (r == p) break;
  }
  r = b->c;
  memcpy(b->s, p, r - p);
  b->c = b->s + (r - p);
  return 0;

  nonlfound:
  return buffer_flush(b);
}
