#include "buffer.h"

int buffer_getline(buffer *b, char *str, int str_size) {
  register int c;
  char *buf = str;

  if ((b == 0) ||
      (b->s == 0) ||
      (b->l == 0) ||
      (str_size < 0) ||
      (str == 0) ||
      (b->fd == -1)) return -2;

  if (str_size == 0) return 0;
  c = buffer_getchar(b);
  if (c < 0) return c;
  if (c == '\r') c = buffer_getchar(b);

  for (;;) {
    if ((c == '\n') || (c == EOF)) { *str = 0; goto out; }
    if (c < 0) return c;
    *str = c; ++str; *str = 0; --str_size;
    if (str_size <= 0) goto out;
    c = buffer_getchar(b);
  }

  out:
  return (int) (str - buf);
}

