#include "buffer.h"

/**
 * Write a single char to a write buffer.
 *
 * On issues with the buffer argument -1 is returned. On issues with the output file or any other I/O error it will return -2.
 *
 * @param b Pointer to the write buffer.
 * @param a The char to put in the buffer.
 * @return On success 0 is returned.
 */
int buffer_putc(buffer *b, register const char a) {
  register char *p;
  register char *s;

  if ((b == 0) ||
      (b->s == 0) ||
      (b->fd == -1) ||
      (b->l != 0)) return -1;

  p = b->c;
  if (p < b->t) goto put;

  s = b->s;
  if (write(b->fd, s, p - s) < 0) return -2;
  p = s;

  put:
  *p = a;
  ++p;
  b->c = p;
  return 0;
}
