#include "buffer.h"

/**
 * Write a string to a write buffer.
 *
 * On issues with the arguments -1 is returned. On other issues -2 is returned.
 *
 * @param b Pointer to the write buffer.
 * @param a The string to put in the buffer.
 * @return On success 0 is returned.
 */
int buffer_putstr(buffer *b, register const char *a) {
  register uint32_t l;

  if (a == 0) return -1;
  l = strlen(a);
  if (l == 0) return 0;
  return buffer_putmem(b, a, l);
}
