#define TEST_BUFFER_FLUSH_BUFSIZE 2

static void test_buffer_flush() {
  int fd;
  const char tempfilename[]="tests/test_tempfile_buffer_flush";
  char buf1space[TEST_BUFFER_FLUSH_BUFSIZE];
  buffer buf1;

  /* initializing */
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSH_BUFSIZE, 1);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  sput_fail_unless(fd >= 0, "open test tempfile");

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_flush(0) == -1, "buffer is 0");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSH_BUFSIZE, 1);
  buf1.s = 0;
  sput_fail_unless(buffer_flush(&buf1) == -1, "buffer has s=0");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSH_BUFSIZE, -1);
  sput_fail_unless(buffer_flush(&buf1) == -1, "buffer has fd=-1");
  buffer_initread(&buf1, buf1space, TEST_BUFFER_FLUSH_BUFSIZE, fd);
  sput_fail_unless(buffer_flush(&buf1) == 0, "buffer is read buffer");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSH_BUFSIZE, fd);

  /* functional tests */
  buffer_putc(&buf1, '1');
  sput_fail_unless(buffer_flush(&buf1) == 0, "buffer_flush() 1 byte with empty buffer");
  close(fd);
  sput_fail_unless(compare_string_to_file_content("1", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSH_BUFSIZE, fd);
  buffer_putmem(&buf1, "12", 2);
  sput_fail_unless(buffer_flush(&buf1) == 0, "buffer_flush() 2 bytes with empty buffer");
  close(fd);
  sput_fail_unless(compare_string_to_file_content("12", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSH_BUFSIZE, fd);
  buffer_putmem(&buf1, "123", 3);
  sput_fail_unless(buffer_flush(&buf1) == 0, "buffer_flush() 3 bytes with empty buffer");
  close(fd);
  sput_fail_unless(compare_string_to_file_content("123", tempfilename) == 0, "check output written");
}

