#define TEST_BUFFER_FLUSHLINES_BUFSIZE 5

static void test_buffer_flushlines() {
  int fd;
  const char tempfilename[]="tests/test_tempfile_buffer_flushlines";
  char buf1space[TEST_BUFFER_FLUSHLINES_BUFSIZE];
  buffer buf1;

  /* initializing */
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSHLINES_BUFSIZE, 1);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  sput_fail_unless(fd >= 0, "open test tempfile");

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_flushlines(0) == -1, "buffer is 0");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSHLINES_BUFSIZE, 1);
  buf1.s = 0;
  sput_fail_unless(buffer_flushlines(&buf1) == -1, "buffer has s=0");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSHLINES_BUFSIZE, -1);
  sput_fail_unless(buffer_flushlines(&buf1) == -1, "buffer has fd=-1");
  buffer_initread(&buf1, buf1space, TEST_BUFFER_FLUSHLINES_BUFSIZE, fd);
  sput_fail_unless(buffer_flushlines(&buf1) == -1, "buffer is read buffer");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSHLINES_BUFSIZE, fd);

  /* functional tests */
  sput_fail_unless(buffer_flushlines(&buf1) == 0, "buffer_flushlines() with empty buffer");
  close(fd);
  sput_fail_unless(compare_string_to_file_content("", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSHLINES_BUFSIZE, fd);
  buffer_putmem(&buf1, "1\n2", 3);
  sput_fail_unless(buffer_flushlines(&buf1) == 0, "buffer_flushlines() 1\\n2");
  sput_fail_unless(compare_string_to_file_content("1\n", tempfilename) == 0, "check output written");
  close(fd);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_FLUSHLINES_BUFSIZE, fd);
  buffer_putmem(&buf1, "\n1\n2", 3);
  sput_fail_unless(buffer_flushlines(&buf1) == 0, "buffer_flushlines() \\n1\\n2");
  sput_fail_unless(compare_string_to_file_content("\n1\n", tempfilename) == 0, "check output written");
  close(fd);
}

