#define TEST_BUFFER_GETCHAR_BUFSIZE 2

static void test_buffer_getchar() {
  int fd;
  const char filename[]="tests/testfile_buffer_getchar";
  char buf0space[TEST_BUFFER_GETCHAR_BUFSIZE];
  buffer buf0;

  /* initializing */
  fd = open(filename, O_RDONLY);
  sput_fail_unless(fd >= 0, "open test tempfile");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETCHAR_BUFSIZE, fd);

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_getchar(0) == -2, "buffer is 0");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETCHAR_BUFSIZE, 1);
  buf0.s = 0;
  sput_fail_unless(buffer_getchar(&buf0) == -2, "buffer has s=0");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETCHAR_BUFSIZE, -1);
  sput_fail_unless(buffer_getchar(&buf0) == -2, "buffer has fd=-1");
  buffer_initwrite(&buf0, buf0space, TEST_BUFFER_GETCHAR_BUFSIZE, fd);
  sput_fail_unless(buffer_getchar(&buf0) == -2, "buffer is write buffer");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETCHAR_BUFSIZE, fd);

  /* functional tests */
  sput_fail_unless(buffer_getchar(&buf0) == '1', "read #1");
  sput_fail_unless(buffer_getchar(&buf0) == '2', "read #2");
  sput_fail_unless(buffer_getchar(&buf0) == '3', "read #3");
  sput_fail_unless(buffer_getchar(&buf0) == '4', "read #4");
  sput_fail_unless(buffer_getchar(&buf0) == '5', "read #5");
  sput_fail_unless(buffer_getchar(&buf0) == EOF, "read EOF");
  sput_fail_unless(buffer_getchar(&buf0) == EOF, "read EOF #2");
  close(fd);
}

