#define TEST_BUFFER_GETLINE_BUFSIZE 2

static void test_buffer_getline() {
  int fd;
  const char filename[]="tests/testfile_buffer_getline";
  char buf0space[TEST_BUFFER_GETLINE_BUFSIZE];
  buffer buf0;
  char line[6];

  /* initializing */
  fd = open(filename, O_RDONLY);
  sput_fail_unless(fd >= 0, "open test tempfile");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETLINE_BUFSIZE, fd);

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_getline(0, line, 0) == -2, "buffer is 0");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETLINE_BUFSIZE, 1);
  buf0.s = 0;
  sput_fail_unless(buffer_getline(&buf0, line, 0) == -2, "buffer has s=0");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETLINE_BUFSIZE, -1);
  sput_fail_unless(buffer_getline(&buf0, line, 0) == -2, "buffer has fd=-1");
  buffer_initwrite(&buf0, buf0space, TEST_BUFFER_GETLINE_BUFSIZE, fd);
  sput_fail_unless(buffer_getline(&buf0, line, 0) == -2, "buffer is write buffer");
  buffer_initread(&buf0, buf0space, TEST_BUFFER_GETLINE_BUFSIZE, fd);
  sput_fail_unless(buffer_getline(&buf0, 0, 6) == -2, "target string is 0");

  /* functional tests */
  sput_fail_unless(buffer_getline(&buf0, line, 0) == 0, "target string 0 len");
  sput_fail_unless(buffer_getline(&buf0, line, 6) == 5, "read line #1");
  sput_fail_unless(strcmp(line, "12345") == 0, "check content line #1");
  sput_fail_unless(buffer_getline(&buf0, line, 6) == 5, "read line #2");
  sput_fail_unless(strcmp(line, "12345") == 0, "check content line #2");
  sput_fail_unless(buffer_getline(&buf0, line, 6) == -1, "read EOF");
  close(fd);
}

