#define TEST_BUFFER_PUTC_BUFSIZE 2

static void test_buffer_putc() {
  int fd;
  const char tempfilename[]="tests/test_tempfile_buffer_putc";
  char buf1space[TEST_BUFFER_PUTC_BUFSIZE];
  buffer buf1;

  /* initializing */
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTC_BUFSIZE, 1);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  sput_fail_unless(fd >= 0, "open test tempfile");

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_putc(0, 'a') == -1, "buffer is 0");
  buffer_initread(&buf1, buf1space, TEST_BUFFER_PUTC_BUFSIZE, fd);
  sput_fail_unless(buffer_putc(&buf1, 'a') == -1, "buffer is read buffer");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTC_BUFSIZE, -1);
  sput_fail_unless(buffer_putc(&buf1, 'a') == -1, "buffer has fd -1");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTC_BUFSIZE, fd);

  /* functional tests */
  sput_fail_unless(buffer_putc(&buf1, '1') == 0, "buffer_putc() with empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("1", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTC_BUFSIZE, fd);
  buffer_putc(&buf1,'1');
  buffer_putc(&buf1,'2');
  sput_fail_unless(buffer_putc(&buf1, '3') == 0, "multiple buffer_putc()");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("123", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, 1, fd);
  sput_fail_unless(buffer_putc(&buf1, '1') == 0, "buffer_putc() with empty buffer - 1 byte buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("1", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, 1, fd);
  buffer_putc(&buf1,'1');
  buffer_putc(&buf1,'2');
  sput_fail_unless(buffer_putc(&buf1, '3') == 0, "multiple buffer_putc() - 1 byte buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("123", tempfilename) == 0, "check output written");
}

