#define TEST_BUFFER_PUTMEM_BUFSIZE 2

static void test_buffer_putmem() {
  int fd;
  const char tempfilename[]="tests/test_tempfile_buffer_putmem";
  char buf1space[TEST_BUFFER_PUTMEM_BUFSIZE];
  buffer buf1;

  /* initializing */
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, 1);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  sput_fail_unless(fd >= 0, "open test tempfile");

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_putmem(0, "a", 1) == -1, "buffer is 0");
  buffer_initread(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, fd);
  sput_fail_unless(buffer_putmem(&buf1, "a", 1) == -1, "buffer is read buffer");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, -1);
  sput_fail_unless(buffer_putmem(&buf1, "a", 1) == -1, "buffer has fd -1");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, fd);

  /* functional tests */
  sput_fail_unless(buffer_putmem(&buf1, "1", 1) == 0, "buffer_putmem() 1 byte with empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("1", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, fd);
  sput_fail_unless(buffer_putmem(&buf1, "12", 2) == 0, "buffer_putmem() 2 bytes with empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("12", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, fd);
  sput_fail_unless(buffer_putmem(&buf1, "123", 3) == 0, "buffer_putmem() 3 bytes with empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("123", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, fd);
  buffer_putc(&buf1, '0');
  sput_fail_unless(buffer_putmem(&buf1, "12", 2) == 0, "buffer_putmem() 2 bytes with non-empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("012", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTMEM_BUFSIZE, fd);
  buffer_putc(&buf1, '0');
  sput_fail_unless(buffer_putmem(&buf1, "1234", 4) == 0, "buffer_putmem() 4 bytes with non-empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("01234", tempfilename) == 0, "check output written");
}

