#define TEST_BUFFER_PUTSTR_BUFSIZE 2

static void test_buffer_putstr() {
  int fd;
  const char tempfilename[]="tests/test_tempfile_buffer_putstr";
  char buf1space[TEST_BUFFER_PUTSTR_BUFSIZE];
  buffer buf1;

  /* initializing */
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, 1);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  sput_fail_unless(fd >= 0, "open test tempfile");

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_putstr(0, "a") == -1, "buffer is 0");
  buffer_initread(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, fd);
  sput_fail_unless(buffer_putstr(&buf1, "a") == -1, "buffer is read buffer");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, -1);
  sput_fail_unless(buffer_putstr(&buf1, "a") == -1, "buffer has fd -1");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, fd);
  sput_fail_unless(buffer_putstr(&buf1, 0) == -1, "buffer_putstr() string is 0");
  sput_fail_unless(buffer_putstr(&buf1, "") == 0, "buffer_putstr() string has size 0");

  /* functional tests */
  sput_fail_unless(buffer_putstr(&buf1, "1") == 0, "buffer_putstr() 1 byte with empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("1", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, fd);
  sput_fail_unless(buffer_putstr(&buf1, "12") == 0, "buffer_putstr() 2 bytes with empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("12", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, fd);
  sput_fail_unless(buffer_putstr(&buf1, "123") == 0, "buffer_putstr() 3 bytes with empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("123", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, fd);
  buffer_putc(&buf1, '0');
  sput_fail_unless(buffer_putstr(&buf1, "12") == 0, "buffer_putstr() 2 bytes with non-empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("012", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTSTR_BUFSIZE, fd);
  buffer_putc(&buf1, '0');
  sput_fail_unless(buffer_putstr(&buf1, "1234") == 0, "buffer_putstr() 4 bytes with non-empty buffer");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("01234", tempfilename) == 0, "check output written");
}

