#define TEST_BUFFER_PUTUINT32_BUFSIZE 2

static void test_buffer_putuint32() {
  int fd;
  const char tempfilename[]="tests/test_tempfile_buffer_putuint32";
  char buf1space[TEST_BUFFER_PUTUINT32_BUFSIZE];
  buffer buf1;
  uint32_t ui = 0xfffffffful;

  /* initializing */
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT32_BUFSIZE, 1);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  sput_fail_unless(fd >= 0, "open test tempfile");

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_putuint32(0, ui) == -1, "buffer is 0");
  buffer_initread(&buf1, buf1space, TEST_BUFFER_PUTUINT32_BUFSIZE, fd);
  sput_fail_unless(buffer_putuint32(&buf1, ui) == -1, "buffer is read buffer");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT32_BUFSIZE, -1);
  sput_fail_unless(buffer_putuint32(&buf1, ui) == -1, "buffer has fd -1");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT32_BUFSIZE, fd);

  /* functional tests */
  sput_fail_unless(buffer_putuint32(&buf1, ui) == 0, "UINT32_MAX");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("4294967295", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT32_BUFSIZE, fd);
  sput_fail_unless(buffer_putuint32(&buf1, 0) == 0, "0");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("0", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT32_BUFSIZE, fd);
  sput_fail_unless(buffer_putuint32(&buf1, 1) == 0, "1");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("1", tempfilename) == 0, "check output written");
}

