#define TEST_BUFFER_PUTUINT64_BUFSIZE 2

static void test_buffer_putuint64() {
  int fd;
  const char tempfilename[]="tests/test_tempfile_buffer_putuint64";
  char buf1space[TEST_BUFFER_PUTUINT64_BUFSIZE];
  buffer buf1;
  uint64_t ui = 0xffffffffffffffffull;

  /* initializing */
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT64_BUFSIZE, 1);

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  sput_fail_unless(fd >= 0, "open test tempfile");

  /* tests */

  /* simple tests of argument */
  sput_fail_unless(buffer_putuint64(0, ui) == -1, "buffer is 0");
  buffer_initread(&buf1, buf1space, TEST_BUFFER_PUTUINT64_BUFSIZE, fd);
  sput_fail_unless(buffer_putuint64(&buf1, ui) == -1, "buffer is read buffer");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT64_BUFSIZE, -1);
  sput_fail_unless(buffer_putuint64(&buf1, ui) == -1, "buffer has fd -1");
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT64_BUFSIZE, fd);

  /* functional tests */
  sput_fail_unless(buffer_putuint64(&buf1, ui) == 0, "UINT64_MAX");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("18446744073709551615", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT64_BUFSIZE, fd);
  sput_fail_unless(buffer_putuint64(&buf1, 0) == 0, "0");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("0", tempfilename) == 0, "check output written");

  fd = open(tempfilename, TEST_BUFFER_CREATE_MODE, TEST_BUFFER_FILE_PERMISSIONS);
  buffer_initwrite(&buf1, buf1space, TEST_BUFFER_PUTUINT64_BUFSIZE, fd);
  sput_fail_unless(buffer_putuint64(&buf1, 1) == 0, "1");
  buffer_flush(&buf1);
  close(fd);
  sput_fail_unless(compare_string_to_file_content("1", tempfilename) == 0, "check output written");
}

